//--------------------------------------------------------------------------
// EnumTopMost.js - Enumerates all visible top most windows and prints 
//                  window list to the standard output (when using CSCRIPT)
//
// This file is part of the sgWindow.
// Copyright (C) 1998 Stinga
// All rights reserved.
//
// This sample demonstrates usage of the sgWindow component
// and it's window enumeration capabilities.
//--------------------------------------------------------------------------


var ws_OVERLAPPED           = 0x00000000;
var ws_POPUP                = 0x80000000;
var ws_CHILD                = 0x40000000;
var ws_MINIMIZE             = 0x20000000;
var ws_VISIBLE              = 0x10000000;
var ws_DISABLED             = 0x08000000;
var ws_CLIPSIBLINGS         = 0x04000000;
var ws_CLIPCHILDREN         = 0x02000000;
var ws_MAXIMIZE             = 0x01000000;
var ws_CAPTION              = 0x00C00000;
var ws_BORDER               = 0x00800000;
var ws_DLGFRAME             = 0x00400000;
var ws_VSCROLL              = 0x00200000;
var ws_HSCROLL              = 0x00100000;
var ws_SYSMENU              = 0x00080000;
var ws_THICKFRAME           = 0x00040000;
var ws_GROUP                = 0x00020000;
var ws_TABSTOP              = 0x00010000;
var ws_MINIMIZEBOX          = 0x00020000;
var ws_MAXIMIZEBOX          = 0x00010000;
var ws_TILED                = 0x00000000;
var ws_ICONIC               = 0x20000000;
var ws_SIZEBOX              = 0x00040000;
var ws_OVERLAPPEDWINDOW     = 0x00CF0000;
var ws_POPUPWINDOW          = 0x80880000;
var ws_CHILDWINDOW          = 0x40000000;
var ws_TILEDWINDOW          = 0x00CF0000;

var jsCrLf = "\r\n";

// Collect window list
var sList = GetTopMostList();

WScript.Echo(sList);
WScript.Echo("This list was generated with Stinga sgWindow component." + jsCrLf + "Copyright (C) 1998 Stinga");

WScript.Quit();

function GetTopMostList()
{    
	var sList = "";
	var style = ws_OVERLAPPEDWINDOW | ws_VISIBLE;

	// Create window object
	var g = new ActiveXObject("SGWindow.Globals");
	
	// Create JScript enumerator
	var children = new Enumerator(g.DesktopWindow.Children);

	// Enumerate all topmost windows and extract 
	// overlapped and visible windows
	for (; !children.atEnd(); children.moveNext())    
	{        
		var child = children.item();		
		if ((child.Style & style) == style)
		{
			sList = sList + child.Class + " - '" + child.Text 
							    //+ "' (" + child.HWND.toString() + " - "
							    //+ child.Style.toString() + ") " 
							    + jsCrLf;
		}
	}
	return sList;
}

