Attribute VB_Name = "modMisc"
Option Explicit

Public Const sSGWindowGUID = "{602B8906-F7EA-11D1-9825-204C4F4F5020}"

' Win32 Registry functions
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" (ByVal hKey As Long, ByVal lpValueName As String, lpData As Any, lpcbData As Long) As Long

' Registry API constants
Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_USERS = &H80000003
Private Const HKEY_PERFORMANCE_DATA = &H80000004
Private Const HKEY_CURRENT_CONFIG = &H80000005
Private Const HKEY_DYN_DATA = &H80000006
Private Const ERROR_SUCCESS = 0&



Public Function ServerPathFromGUID(sGuid$) As String
   Dim hKey As Long
   Dim nRet As Long
   Dim sKey As String
   
   ServerPathFromGUID = ""
   sKey = "CLSID\" & sGuid & "\InProcServer32"
   nRet = RegOpenKey(HKEY_CLASSES_ROOT, sKey, hKey)
   If nRet = ERROR_SUCCESS Then
      Dim nLen As Long
      nRet = RegQueryValue(hKey, vbNullString, 0, nLen)
      Dim sBuff As String
      sBuff = Space(nLen)
      nRet = RegQueryValue(hKey, vbNullString, ByVal sBuff, Len(sBuff))
      ServerPathFromGUID = sBuff
   End If
End Function

Public Sub FillMessages(combo As ComboBox)
   Dim tlib As tli.TypeLibInfo
   Dim msgs As tli.ConstantInfo
   Dim sFile As String
   
   combo.Clear
   
   ' Get SGWindow DLL path
   sFile = ServerPathFromGUID(sSGWindowGUID)
   If (Len(sFile) = 0) Then Exit Sub
   
   ' Get type library info for the SGWindow component
   Set tlib = tli.TLIApplication.TypeLibInfoFromFile(sFile)
   Set msgs = tlib.Constants.NamedItem("WinMsg")
   
   ' Fill combo
   Dim ci As tli.MemberInfo
   For Each ci In msgs.Members
      combo.AddItem UCase(ci.name)
   Next
   combo.ListIndex = 0
End Sub

Public Function GetMessageCode(sMsgName$) As Long
   Dim tlib As New tli.TypeLibInfo
   Dim msgs As tli.ConstantInfo
   Dim sFile As String
   
   GetMessageCode = wm_NULL
   
   ' Get SGWindow DLL path
   sFile = ServerPathFromGUID(sSGWindowGUID)
   If (Len(sFile) = 0) Then Exit Function
   
   ' Get type library info for the SGWindow component
   Set tlib = tli.TLIApplication.TypeLibInfoFromFile(sFile)
   Set msgs = tlib.Constants.NamedItem("WinMsg")
   
   ' Find message
   Dim ci As tli.MemberInfo
   For Each ci In msgs.Members
      If UCase(sMsgName) = UCase(ci.name) Then
         GetMessageCode = ci.Value
         Exit Function
      End If
   Next
End Function

Public Function GetMessageName(msg As Long) As String
   Dim tlib As New tli.TypeLibInfo
   Dim msgs As tli.ConstantInfo
   Dim sFile As String
   
   GetMessageName = "Unknown"
   
   ' Get SGWindow DLL path
   sFile = ServerPathFromGUID(sSGWindowGUID)
   If (Len(sFile) = 0) Then Exit Function
   
   ' Get type library info for the SGWindow component
   Set tlib = tli.TLIApplication.TypeLibInfoFromFile(sFile)
   Set msgs = tlib.Constants.NamedItem("WinMsg")
   
   ' Find message
   Dim ci As tli.MemberInfo
   For Each ci In msgs.Members
      If msg = ci.Value Then
         GetMessageName = UCase(ci.name)
         Exit Function
      End If
   Next
End Function
